/****************************************************************************/
/*!
   	@file		StraightDatabase1_pub.h
 	
	@author 	Yamamoto
 	@date 		2007-9-12
*/
/****************************************************************************/

#ifndef		StraightDatabase1_pub_hpp
#define		StraightDatabase1_pub_hpp

///////////////////////////////////////////////////////////////////////////
//include files
#include	"Real.h"
#include	"../Array1/Array1_pub.h"

namespace StraightDatabase1
{
///////////////////////////////////////////////////////////////////////////
// preprocessor deifne

///////////////////////////////////////////////////////////////////////////
// type define

///////////////////////////////////////////////////////////////////////////
// classes define

/****************************************************************************
 StraightDatabase
****************************************************************************/
/*===========================================================================
[ class purpose ]
===========================================================================*/
/////////////////////////////////////////////////////////////////////////////
template < class DATA >
class StraightDatabase
{
	real_copy_impossible( StraightDatabase );
	
// variable
private:
	Array1::Array< DATA* >		m_PtrList;
	
// private functions 
private:
// protected functions
protected:
// public functions 
public:
/*===========================================================================
Construct
                                               
@retval			---
---------------------------------------------------------------------------*/
StraightDatabase() : m_PtrList( Array1::ConstantCash , 20 )
{
}
/*===========================================================================
Construct
                                               
@retval			---
---------------------------------------------------------------------------*/
StraightDatabase
		(
		int		num
		) : m_PtrList( Array1::ConstantCash , 20 )
{
	Resize( num );
}
/*===========================================================================
Destruct
                                               
@retval			---
---------------------------------------------------------------------------*/
~StraightDatabase()
{
	Resize( 0 );
}
/*===========================================================================
reference operator
                                               
@retval			---
---------------------------------------------------------------------------*/
DATA& operator[]
		(
		int		n
		)
{
	return *m_PtrList[ n ];
}
/*===========================================================================
reference operator
                                               
@retval			---
---------------------------------------------------------------------------*/
const DATA& operator[]
		(
		int		n
		)const
{
	return *m_PtrList[ n ];
}
/*===========================================================================
resize
                                               
@retval			---
---------------------------------------------------------------------------*/
void Resize
		(
		int		num
		)
{
	int		off , datanum	= m_PtrList.GetDataNum();
	if ( datanum > num )
	{
		//if data is less , free odd data.
		for ( off = num ; off < datanum ; off++ )
		{
			delete m_PtrList[ off ];
		}
		m_PtrList.ResizeHold( num , 0 );
	}
	else if( datanum < num )
	{
		m_PtrList.ResizeHold( num , 0 );
		for ( off = datanum ; off < num ; off++ )
			m_PtrList[ off ]	= new	DATA;
	}
}
/*===========================================================================
add data.
                                               
@retval			---
---------------------------------------------------------------------------*/
int AddData()
{
	int		num	= m_PtrList.GetDataNum();
	Resize( num + 1 );
	return num;
}
/*===========================================================================
insert data.
                                               
@retval			---
---------------------------------------------------------------------------*/
void InsertData
		(
		int		off
		)
{
	m_PtrList.InsertData( off , 0 );
	m_PtrList[ off ] = new DATA;
}
/*===========================================================================
delete data.
                                               
@retval			---
---------------------------------------------------------------------------*/
void DeleteData
		(
		int		off
		)
{
	delete	( m_PtrList[ off ] );
	m_PtrList.DeleteData( off );
}
/*===========================================================================
get data num.
                                               
@retval			---
---------------------------------------------------------------------------*/
int GetDataNum()const
{
	return m_PtrList.GetDataNum();
}
/*===========================================================================
exchange data.
                                               
@retval			---
---------------------------------------------------------------------------*/
void Exchange
		(
		int		s_off ,			//!< [in] exchange src
		int		t_off			//!< [in] exchange dest
		)
{
	DATA	*s_ptr	= m_PtrList[ s_off ];

	m_PtrList[ s_off ]	= m_PtrList[ t_off ];
	m_PtrList[ t_off ]	= s_ptr;
}
/*===========================================================================
check existance of the data.
                                               
@retval			---
---------------------------------------------------------------------------*/
bool IsDataExist
		(
		int		off
		)const
{
	if( off < 0 || off >= GetDataNum() )
		return false;
	return true;
}
};

///////////////////////////////////////////////////////////////////////////
// global variable define

///////////////////////////////////////////////////////////////////////////
// global functions define

};	//namespace StraightDatabase1

//using namespace StraightDatabase1;		

#endif
