/****************************************************************************/
/*!
   	@file		DllMain1_pri.h
	@author 	Fanzo
 	@date 		2007/10/17
*/
/****************************************************************************/

#ifndef		DllMain1_pri_h
#define		DllMain1_pri_h

///////////////////////////////////////////////////////////////////////////
// private settings
#include	"DllMain1_pub.h"

///////////////////////////////////////////////////////////////////////////
// include files
#include	"Real.h"
#include	"../../../../SharedSource/common/Thread1/CriticalSection1/CriticalSection1_pub.h"
#include	"../../../../SharedSource/common/Thread1/Thread1/Thread1_pub.h"
#include	"../GC1/GC1_pub.h"

#ifdef __linux__
	#include	<pthread.h>
#endif

using namespace real;
using namespace DllMain1;

namespace DllMain1
{
///////////////////////////////////////////////////////////////////////////
// private presprocessor define

///////////////////////////////////////////////////////////////////////////
// private classes

/****************************************************************************
"DllMain" class 
****************************************************************************/
/*===========================================================================
//!	
===========================================================================*/
/////////////////////////////////////////////////////////////////////////////
class DllMain : public GC1::GC
{
// variable member
public:
	real::int32					m_InitializeCount;
	Thread1::CriticalSection		m_InitializeCS;
	
// private functions
private:
// protect functions
protected:
// public functions
public:
//=======================================================================
//!	construct
//-----------------------------------------------------------------------
DllMain();
//=======================================================================
//!	destruct
//-----------------------------------------------------------------------
~DllMain();
//=======================================================================
//!	Initialize
//!	@retval			---
//-----------------------------------------------------------------------
void InitializeReal();
//=======================================================================
//!	Uninitialize
//!	@retval			---
//-----------------------------------------------------------------------
void UninitializeReal();

};

///////////////////////////////////////////////////////////////////////////
// private variables

static
DllMain			m_Main;

};	//namespace DllMain1

// export tls index
//DWORD __real_TlsIndex;
#ifdef WIN32
	real_dll_export
	DWORD				__real_TlsIndex = 0xFFFFFFFF;
#elif __APPLE__
	real_dll_export
	TaskStorageIndex	__real_TlsIndex	= 0;
#elif __linux__
	real_dll_export
	pthread_key_t		__real_TlsIndex = 0;
#endif


#endif

