/****************************************************************************/
/*!
   	@file		Que1_pub.h
	@author 	Fanzo
 	@date 		2007/10/28
*/
/****************************************************************************/

#ifndef		Que1_pub_h
#define		Que1_pub_h

///////////////////////////////////////////////////////////////////////////
//include files
#include	"Real.h"
#include	"../../StraightDatabase1/StraightDatabase1_pub.h"
#include	"../CriticalSection1/CriticalSection1_pub.h"
#include	"../Semaphore1/Semaphore1_pub.h"

namespace Thread1
{
using namespace real;
///////////////////////////////////////////////////////////////////////////
// preprocessor deifne

///////////////////////////////////////////////////////////////////////////
// type define

///////////////////////////////////////////////////////////////////////////
// classes define

/****************************************************************************
"Que" class 
****************************************************************************/
/*===========================================================================
//!	
===========================================================================*/
/////////////////////////////////////////////////////////////////////////////
template< class T >
class Que
{
	real_copy_impossible( Que );

// variable member
private:
	StraightDatabase1::StraightDatabase< T >	m_Que;
	int					m_ReadPos;
	int					m_WritePos;
	CriticalSection		m_CS;
	Semaphore			m_Count;
	Semaphore			m_Empty;

// private functions
private:
// protect functions
protected:
// public functions
public:
//=======================================================================
//!	construct
//-----------------------------------------------------------------------
Que
	(
	int32	quemax
	) 
	:m_Que( quemax ) , 
	m_ReadPos( 0 ) , 
	m_WritePos( 0 ) , 
	m_Count( 0 , quemax ) , 
	m_Empty( quemax , quemax )
{
}
//=======================================================================
//!	destruct
//-----------------------------------------------------------------------
~Que()
{
}
//=======================================================================
//!	reset
//!	@retval			---
//-----------------------------------------------------------------------
void Reset()
{
	T	data;
	while( true == Pop( &data , 0 ) );
}
//=======================================================================
//!	push
//!	@retval			---
//-----------------------------------------------------------------------
void Push
		(
		T	&data
		)
{
	m_Empty.Wait();
	m_CS.Lock();
	m_Que[ m_WritePos ] = data;
	m_WritePos++;
	if( m_WritePos == m_Que.GetDataNum() )
		m_WritePos = 0;
	m_CS.Unlock();
	m_Count.Post();
}

//=======================================================================
//!	pop
//!	@retval			---
//-----------------------------------------------------------------------
T Pop()
{
	T	r;
	m_Count.Wait();
	m_CS.Lock();
	r = m_Que[ m_ReadPos ];
	m_ReadPos++;
	if( m_ReadPos == m_Que.GetDataNum() )
		m_ReadPos = 0;
	m_CS.Unlock();
	m_Empty.Post();
	return r;
}
//=======================================================================
//!	pop timeout
//!	@retval			if timeout , return false
//-----------------------------------------------------------------------
bool Pop
		(
		T		*pdata , 
		uint32	msec
		)
{
	if( false == m_Count.WaitTimeout( msec ) )
		return false;
	m_CS.Lock();
	*pdata = m_Que[ m_ReadPos ];
	m_ReadPos++;
	if( m_ReadPos == m_Que.GetDataNum() )
		m_ReadPos = 0;
	m_CS.Unlock();
	m_Empty.Post();
	return true;
}
};
///////////////////////////////////////////////////////////////////////////
// global variable define

///////////////////////////////////////////////////////////////////////////
// global functions define

};	//namespace Que1

//using namespace Que1;		

#endif

