/****************************************************************************/
/*!
   	@file		RealLib1.cpp
 	
	@author 	Fanzo
 	@date 		2007/10/16
*/
/****************************************************************************/
#include			"RealLib1_pri.h" 

namespace RealLib1
{
/****************************************************************************
"" class define
****************************************************************************/
///////////////////////////////////////////////////////////////////////////
// private functions

///////////////////////////////////////////////////////////////////////////
// protected functions

///////////////////////////////////////////////////////////////////////////
// public functions


/****************************************************************************
static functions define
****************************************************************************/
//=======================================================================
//!	Initialize
//!	@retval			---
//-----------------------------------------------------------------------
static
bool Initialize()
{
	__real_InitializeReal();
	return true;
}
//=======================================================================
//!	Uninitialize
//!	@retval			---
//-----------------------------------------------------------------------
static
void Uninitialize()
{
	__real_UninitializeReal();
}
};//namespace RealLib1

namespace real
{
//=======================================================================
//!	initialize real
//!	@retval			---
//-----------------------------------------------------------------------
void real_call InitializeReal()
{
	Thread1::Autolock		autolock( RealLib1::m_InitializeCS );

	if( RealLib1::m_InitializeCount == 0 )
	{
		if( false == RealLib1::Initialize() )
			return;
	}
	RealLib1::m_InitializeCount++;
	return;
}
//=======================================================================
//!	uninitialize
//!	@retval			---
//-----------------------------------------------------------------------
void real_call UninitializeReal()
{
	Thread1::Autolock		autolock( RealLib1::m_InitializeCS );

	RealLib1::m_InitializeCount--;
	real_assert( RealLib1::m_InitializeCount >= 0 , "Counter detected minus value." );
	if( RealLib1::m_InitializeCount == 0 )
	{
		RealLib1::Uninitialize();
	}
}
//=======================================================================
//!	regist
//!	@retval			---
//-----------------------------------------------------------------------
bool real_call RegistRealGC
		(
		gc_info		*pinfo
		)
{
	return __real_RegistRealGC( pinfo );
}
//=======================================================================
//!	collrect gc
//!	@retval			---
//-----------------------------------------------------------------------
void real_call CollectGC
		(
		bool	sync , 
		bool	integrate
		)
{
	__real_CollectGC( sync , integrate );
}
//=======================================================================
//!	get memory size
//!	@retval			---
//-----------------------------------------------------------------------
uint32 real_call GetMemorySize()
{
	return __real_GetMemorySize();
}
//=======================================================================
//!	set collect setting
//!	@retval			---
//-----------------------------------------------------------------------
void real_call SetCollectSetting
		(
		CollectSetting	&setting
		)
{
	__real_SetCollectSetting( setting );
}
//=======================================================================
//!	get collect setting
//!	@retval			---
//-----------------------------------------------------------------------
void real_call GetCollectSetting
		(
		CollectSetting	*psetting
		)
{
	__real_GetCollectSetting( psetting );
}
//=======================================================================
//!	set gc thread priority
//!	@retval			---
//-----------------------------------------------------------------------
bool real_call SetGCThreadPriority
		(
		GCThreadPriority	priority
		)
{
	return __real_SetGCThreadPriority( priority );
}
//=======================================================================
//!	get gc thread priority
//!	@retval			---
//-----------------------------------------------------------------------
GCThreadPriority real_call GetGCThreadPriority()
{
	return __real_GetGCThreadPriority();
}
//=======================================================================
//!	set gc thread processor
//!	@retval			---
//-----------------------------------------------------------------------
bool real_call SetGCThreadProcessor
		(
		int		processor_id
		)
{
	return __real_SetGCThreadProcessor( processor_id );
}

};//namespace real

