/****************************************************************************/
/*!
   	@file		Misc.h
	@author 	Fanzo
 	@date 		2007/10/18
*/
/****************************************************************************/

#ifndef		real_Misc_h
#define		real_Misc_h

///////////////////////////////////////////////////////////////////////////
//include files


#pragma pack( push , 1 )		//set align

namespace real
{

///////////////////////////////////////////////////////////////////////////
// preprocessor deifne

// atomic functions. variable is nessesary to be aline 32.
#ifdef WIN32
	#define		real_atomic_increment( a )				InterlockedIncrement( a )
	#define		real_atomic_decrement( a )				InterlockedDecrement( a )
//	#define		real_atomic_exchange( dest , val )		InterlockedExchange( dest , val )
#elif defined(__APPLE__) || defined(__linux__)
	#define		real_atomic_increment( a )				IncrementAtomic( a )
	#define		real_atomic_decrement( a )				DecrementAtomic( a )
//	#define		real_atomic_exchange( dest , val )		CompareAndSwap( dest , val )?????????
#else
	#error	UnknownOS
#endif


//copy impossible
#define		real_copy_impossible( a )							\
private:														\
a( const a& obj );												\
a& operator= ( const a& obj );									

//copy construct is impossible
#define		real_copyconstruct_impossible( a )					\
private:														\
a( const a& obj );												

//substitution operator is impossible
#define		real_assign_impossible( a )							\
private:														\
a& operator= ( const a& obj );									

//if execute copy construct , do assert.
#define		real_copyconstruct_assert( a )							\
public:																\
a( const a& obj )													\
{																	\
	real_assert( false , "copy construct which is prohibited wat called." );	\
}

//if execute copy construct , do assert
#define		real_copy_impossible_assert( a )						\
private:														\
a& operator= ( const a& obj );									\
public:															\
a( const a& obj )												\
{																\
	real_assert( false , "copy construct which is prohibited was called." );	\
}

//table num.
#define		real_countof( a )		( sizeof( ( a ) ) / sizeof( a[ 0 ] ) )
#define		real_unused( a )			(void)(a)

///////////////////////////////////////////////////////////////////////////
// type define

///////////////////////////////////////////////////////////////////////////
// classes define

///////////////////////////////////////////////////////////////////////////
// global variable define

///////////////////////////////////////////////////////////////////////////
// global functions define

};	//namespace

//using namespace real;		

#pragma pack( pop )			//release align

#endif

