﻿#include	"real.h"

using namespace real;


//GCオブジェクトを作成するときは必ずgc_obj_baseをvirtualで継承する
class HelloGC : virtual public gc_obj_base
{
public:
	int		val;
HelloGC() : val( 0 )
{
	printf( "HelloGC::Constructed.\n" );
}
~HelloGC()
{
	printf( "HelloGC::Destructed.\n" );
}
void ShowMessage()
{
	printf( "HelloGC\n" );
}
void ShowVal()
{
	printf( "val = %d\n" , val );
}
};
int main()
{
	// GCを使う前に初期化する。
	InitializeReal();
	{
		// オブジェクトを作成する
		i_obj<HelloGC>	obj = new_iobject<HelloGC>();
	
		//HelloGCのメンバにアクセスするときは->演算子を使う
		obj->ShowMessage();
		obj->val = 100;
		obj->ShowVal();
	}
	// GCを終了するときはUninitializeRealを呼ぶ。InitializeRealを呼び出した回数だけ呼ばなくては解放されない
	// また最後のUninitializeRealを呼んだとき、オブジェクトはすべてreleaseされていないとAssertが呼び出される
	UninitializeReal();
	return 0;
}

